/* 
 Copyright 2005 Kapor Enterprises, Inc. and Todd Agulnick.
 
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 	
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 
 foxmarks-dialog.js: Implements the main foxmarks options dialog.
  
 */
 
function SetupDialog()
{
	document.getElementById("hostname").value = gSettings.hostname;
	document.getElementById("username").value = gSettings.username;
	document.getElementById("password").value = gSettings.password;
	document.getElementById("path").value =     gSettings.path;
	document.getElementById("synchontimer").checked = gSettings.synchOnTimer;
	document.getElementById("servertype").value = gSettings.serverType;
	document.getElementById("lastSynchDate").value = gSettings.lastSynchDisplayDate;
	document.getElementById("version").value = "Foxmarks/" + FoxmarksVersion();

  if (gSettings.debugUI)
    document.getElementById("debugLabel").collapsed = false;
    
	// document.getElementById("autosynchfreq").value = parseInt(gSettings.autoSynchFreq);
	// document.getElementById("synchonstartup").checked = gSettings.synchOnStartup;
	// document.getElementById("synchonshutdown").checked = gSettings.synchOnShutdown;

}
	
function StoreSettingsFromDialog()
{
	gSettings.serverType = document.getElementById("servertype").value;
	gSettings.hostname = document.getElementById("hostname").value;
	gSettings.path = document.getElementById("path").value;
	gSettings.username = document.getElementById("username").value;
	gSettings.password = document.getElementById("password").value;
	gSettings.synchOnTimer = document.getElementById("synchontimer").checked;
	
	// gSettings.autoSynchFreq = document.getElementById("autosynchfreq").value;
	// gSettings.synchOnStartup = document.getElementById("synchonstartup").checked;
	// gSettings.synchOnShutdown = document.getElementById("synchonshutdown").checked;
}


function onLoad()
{
	SetupDialog();
}


function doOK()
{
	StoreSettingsFromDialog();
	return true;
}

function doCancel()
{
	return true;
}

function doHelp()
{
  OpenFileInWindow("http://www.foxcloud.com/wiki/Foxmarks:_Help");
}

function PerformAction(action, arg)
{
	var retval = { helpurl: null };
	
	try {
		var win = window.openDialog("chrome://foxmarks/content/foxmarks-progress.xul", "_blank", "chrome,dialog,modal,centerscreen", action, retval, arg);
		SetupDialog();	// update last synched date
		if (retval.helpurl)
			OpenFileInWindow(retval.helpurl);
	} catch (e) {
		alert(e);
	}
}
	
function UploadNow()
{
	if (confirm(Bundle().GetStringFromName("msg.overwriteremote"))) {
		StoreSettingsFromDialog();
		PerformAction("upload", null);
	}
}

function DownloadNow()
{
	if (confirm(Bundle().GetStringFromName("msg.overwritelocal"))) {
		StoreSettingsFromDialog();
		PerformAction("download", null);
	}
}

function SynchronizeNow()
{
	StoreSettingsFromDialog();
	PerformAction("synch", null);
}

function OpenFileInWindow(url)
{
	openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", url);	
}

function OpenSyncFile()
{
	OpenFileInWindow(gSettings.downloadURL);
}

function resetServerSettings()
{
  if (confirm(Bundle().GetStringFromName("msg.resetserver"))) {
    gSettings.resetServerSettings();
    SetupDialog();
  }
}

function RunSetupWizard()
{
  StoreSettingsFromDialog();
  window.open("chrome://foxmarks/content/foxmarks-setup.xul", "_blank", "chrome,centerscreen,modal");
  SetupDialog();
}

function ClearAllSettings()
{
  if (confirm(Bundle().GetStringFromName("msg.erasesettings"))) {
    if (confirm(Bundle().GetStringFromName("msg.really"))) {
      gSettings.resetAll();
      SetupDialog();
    }
  }
}
