/* 
 Copyright 2005 Kapor Enterprises, Inc. and Todd Agulnick.
 
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 	
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 
 foxmarks-progress.js: handles the UI and top-level logic for
 merge, sync, upload, and download operations.
  
 */

var gCancelled;

var gObserver = {

  onFoxmarksProgress: function(status, msg, complete)
  {
    LogWrite("Progress: status is " + status + ", msg is " + msg)
  	var element = document.getElementById("status");
  	if (element) {
  		element.value = msg;
      if (complete) {
        gCancelled = true;
        if (status == 0)
        setTimeout(window.close, 100);
      }
  	}
  }
};

var gLowProfileObserver = {

  onFoxmarksProgress: function(status, msg, complete)
  {
  	var element = document.getElementById("status");
  	if (element) {
  		element.value = msg;
      if (complete) {
        setTimeout(window.close, 1000);
        window.arguments[1].status = status;
        window.arguments[1].msg = msg;
      }
  	}
  }
};


var gFoxmarksService = null;
	

function onProgressLoad()
{
	gCancelled = false;
	
	// get reference to foxmarks-service to process the request
	gFoxmarksService = Components.classes["@foxcloud.com/extensions/foxmarks;1"].
    getService(Components.interfaces.nsIFoxmarksService);
  
	
	switch (window.arguments[0]) {
		case "upload":
			gFoxmarksService.upload(gObserver);
			break;
		
		case "download":
			gFoxmarksService.download(gObserver);
			break;
		
		case "synch":
			gFoxmarksService.synchronize(gObserver);
			break;
			
		case "verifyAccount":
		  var ca = window.arguments[2];
			gFoxmarksService.verifyAccount(gLowProfileObserver, ca.username, ca.password);
			break;
			
		case "createAccount":
		  var ca = window.arguments[2];
		  gFoxmarksService.createAccount(gLowProfileObserver, ca.username, ca.password,
          ca.firstname, ca.lastname, ca.email);
      break;
          
    case "verifyFile":
      gFoxmarksService.verifyFile(gLowProfileObserver);
		  break;
		  
		case "initialSync":
		  var ca = window.arguments[2];
		  gFoxmarksService.synchronizeInitial(gLowProfileObserver, ca.remoteIsMaster, ca.merge);
		  break;
	}
}

function onProgressCancel()
{
  gFoxmarksService.cancel();
  
	// the first time through, just let callbacks from the cancellation
	// requests above shut us down
	// if we somehow got stuck, allow a second press of the cancel
	// button to actually shut the dialog box down.
	
	if (gCancelled) {
    window.arguments[1].status = -1;
    window.arguments[1].msg = Bundle().GetStringFromName("msg.cancelled");
		return true;
	} else {
		gCancelled = true;
		return false;	// let the callbacks close us down
	}
}

function onProgressHelp()
{
	var element = document.getElementById("status");
	if (element) {
		var errmsg = element.value.replace(" ", "_");
		window.arguments[1].helpurl = Bundle().formatStringFromName("url.error", [errmsg], 1);
		setTimeout(window.close, 100);
	}
	return false;
}
